datablock PlayerData(PlayerAirSwimmer : PlayerStandardArmor)
{
	uiName = "Air Swimmer";
	impactWaterEasy = "";
	impactWaterMedium = "";
	impactWaterHard = "";
	exitingWater = "";
};

function Player::updateZone(%player)
{
	%trigger = %player.airswimtrigger;
	if(isObject(%trigger))
	{
		%ppos = %player.position;
		%zone = %player.airswimzone;
		%pposchange = vectorSub(%trigger.lastppos, %ppos);
		%chx = getWord(%pposchange,0);
		%chy = getWord(%pposchange,1);
		%chz = getWord(%pposchange,2);
		if(%chx>2)
		{
			%chx=2;
		}
		if(%chx<-2)
		{
			%chx=-2;
		}
		if(%chy>2)
		{
			%chy=2;
		}
		if(%chy<-2)
		{
			%chy=-2;
		}
		if(%chz>2)
		{
			%chz=2;
		}
		if(%chz<-2)
		{
			%chz=-2;
		}
		%chx = %chx*0.75;
		%chy = %chy*-0.75;
		%chz = %chz*0.35;
		%zone.setTransform(getWord(%ppos,0)-(3+%chx) SPC getWord(%ppos,1)+(3+%chy) SPC getWord(%ppos,2)-(3.5+%chz));
		%trigger.setTransform(getWord(%ppos,0)-0.52 SPC getWord(%ppos,1)+0.52 SPC getWord(%ppos,2)-0.6);
		%trigger.lastppos = %ppos;
		%zone.sendUpdate();
	}
}

datablock TriggerData(AirSwimTrigger)
{
		tickPeriodMS = 36;
};

function Player::StartFlight(%player)
{
	if(isObject(%player.client))
	{
		%client = %player.client;
		if(!%player.isairswimming)
		{
			%client.oldplayertype = %player.getDatablock();
			%player.setdatablock(PlayerAirSwimmer);
			%ppos = %player.position;
			%zone = new PhysicalZone()
			{
				position = getWord(%ppos,0)-3 SPC getWord(%ppos,1)+3 SPC getWord(%ppos,2)-3.5;
				velocityMod = "1";
				gravityMod = "0";
				extraDrag = "0";
				isWater = "1";
				waterViscosity = "15";
				waterViscosityrDensity = "0.7";
				waterColor = "0.000000 0.000000 0.000000 0.000000";
				appliedForce = "0 0 0";
				polyhedron = "0.0 0.0 0.0 1.0 0.0 0.0 0.0 -1.0 0.0 0.0 0.0 1.0";
				scale = "6 6 7";
			};
 			%trigger = new Trigger()
 			{
				position = getWord(%ppos,0)-0.5 SPC getWord(%ppos,1)+0.5 SPC getWord(%ppos,2);
				rotation = "1 0 0 0";
				scale = "1.4 1.4 1.4";
				dataBlock = "AirSwimTrigger";
				polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
				lastppos = %ppos;
			};
			%client.add(%zone);
			%client.add(%trigger);
			%player.airswimzone = %zone;
			%player.airswimtrigger = %trigger;
			%player.isairswimming = 1;
		}
	}
}

function Player::StopFlight(%player)
{
	if(isObject(%player.client))
	{
		%client = %player.client;
		if(%player.isairswimming)
		{
			%player.airswimzone.delete();
			%player.airswimtrigger.delete();
			%player.isairswimming = 0;
			%player.setdatablock(%client.oldplayertype);
		}
	}
}

package AirSwimBMSupport
{
	function armor::onRemove(%datablock, %player)
	{
		%trigger = %player.airswimtrigger;
		if(isObject(%trigger))
		{
			%player.airswimtrigger.delete();
			%player.airswimzone.delete();
		}
		Parent::onRemove(%datablock, %player);
	}
	function PlayerAirSwimmer::onTrigger(%datablock,%player,%c,%d)
	{
		%trigger = %player.airswimtrigger;
		if(isObject(%player.airswimtrigger))
		{
			%player.updateZone();
		}
		Parent::onTrigger(%datablock,%player,%c,%d);
	}
	function AirSwimTrigger::onLeaveTrigger(%this, %trigger, %player)
	{
		%ptrigger = %player.airswimtrigger;
		if(%ptrigger == %trigger)
		{
			%player.updateZone();
		}
		Parent::onLeaveTrigger(%this, %trigger, %player);
	}
};
if(!$AddOn__Script_AirSwimmer_Extreme)
{
	activatepackage(AirSwimBMSupport);
}

//Anyone trying to follow this script will realize its really confusing and probably poorly written.

//Live with it.

datablock ItemData(EVAJetpackItem)
{
	category = "Item";  // Mission editor category

	equipment = true;

	//its already a member of item namespace so dont break it
	//className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./EVAJetpack.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "EVAJetpack";
	iconName = "./EVAJetpack";
	doColorShift = false;
	colorShiftColor = "0.200 0.200 0.200 1.000";
	
	 // Dynamic properties defined by the scripts
	image = EVAJetpackImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(EVAJetpackImage)
{
	// Basic Item properties
	shapeFile = "./blank.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0.13 0.2 -0.8";
	rotation = eulerToMatrix("0 0 0");
	eyeOffset = "0.13 0.2 -0.8";
	eyeRotation = eulerToMatrix("0 0 0");

	doColorShift = true;
	colorShiftColor = EVAJetpackItem.colorShiftColor;
	

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "ToolImage";

	// Projectile && Ammo.
	item = EVAJetpackItem;

	//melee particles shoot from eye node for consistancy
	melee = true;
	//raise your arm up or not
	armReady = false;

	doColorShift = true;
	colorShiftColor = EVAJetpackItem.colorShiftColor; //"0.200 0.200 0.200 1.000";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0]	= "Ready";


	stateName[1]			= "Ready";
	stateScript[1]			= "onUse";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;


	stateName[2]			= "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]			= "onFire";
};

datablock ShapeBaseImageData(EVAJetpack1Image)
{
	// Basic Item properties
	shapeFile = "./EVAJetpack.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 2;
	offset = "0.65 1 -1.1";
	rotation = eulerToMatrix("0 0 0");
	eyeOffset = "0.65 1 5.1";
	eyeRotation = eulerToMatrix("0 0 0");

	doColorShift = true;
	colorShiftColor = EVAJetpack2Item.colorShiftColor;
	

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "ToolImage";

	// Projectile && Ammo.
	item = EVAJetpack2Item;

	//melee particles shoot from eye node for consistancy
	melee = false;
	//raise your arm up or not
	armReady = false;

	doColorShift = true;
	colorShiftColor = EVAJetpackItem2.colorShiftColor; //"0.200 0.200 0.200 1.000";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0]	= "Ready";

	stateName[1]			= "Ready";
};

datablock ShapeBaseImageData(EVAJetpack2Image)
{
	// Basic Item properties
	shapeFile = "./EVAJetpack1.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 2;
	offset = "0.65 1 -1.1";
	rotation = eulerToMatrix("0 0 0");
	eyeOffset = "0.65 1 5.1";
	eyeRotation = eulerToMatrix("0 0 0");

	doColorShift = true;
	colorShiftColor = EVAJetpack2Item.colorShiftColor;
	

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "ToolImage";

	// Projectile && Ammo.
	item = EVAJetpack2Item;

	//melee particles shoot from eye node for consistancy
	melee = false;
	//raise your arm up or not
	armReady = false;

	doColorShift = true;
	colorShiftColor = EVAJetpackItem2.colorShiftColor; //"0.200 0.200 0.200 1.000";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0]	= "Ready";

	stateName[1]			= "Ready";
};

//called when you click with it on.
function EVAJetpackImage::onFire(%this, %obj, %slot)
{
	%client = %obj.client;
	if(%client.player.EVAJetpacking == 0)
	{
		//do the airswimmy part
		%client.player.startFlight();
		//hide any backpack items if you are wearing them
		%obj.hidenode(cape);
		%obj.hidenode(pack);
		%obj.hidenode(quiver);
		%obj.hidenode(tank);
		%obj.hidenode(armor);
		%obj.hidenode(bucket);
		//mount the EVAJetpack and unmount the un-parachuting EVAJetpack (confusing, I know)
		%client.player.unmountimage(2);
		%client.player.mountimage(EVAJetpack2image, 2);
		%client.player.EVAJetpacking = 1;
		%client.player.playAudio(3, EVAJetpackStart);
		%client.player.EVAJetpackLoop = schedule(1000, 0, EVAJetpackLoop, %client.player);
	}
	else
	{
		%client.player.EVAJetpacking = 0;
		//do the airswimmy part
		%client.player.stopFlight();
		//unmount the EVAJetpack
		%client.player.unmountimage(2);
		//Re-mount the unopened EVAJetpack
		%client.player.mountImage(Para1Image, 2);
		//and rehide this stuff here
		%obj.hidenode(cape);
		%obj.hidenode(pack);
		%obj.hidenode(quiver);
		%obj.hidenode(tank);
		%obj.hidenode(armor);
		%obj.hidenode(bucket);
		cancel(%client.player.EVAJetpackLoop);
		%client.player.playAudio(3, EVAJetpackStart);
	}
}

//mounts the jetpack when you equip it
function EVAJetpackimage::onMount(%this, %user)
{
	%user.playthread(1,root);
	if(%user.EVAJetpacking)
		return;
	%user.mountimage(EVAJetpack1image, 2);
	%obj = %user;
	%obj.hidenode(cape);
	%obj.hidenode(pack);
	%obj.hidenode(quiver);
	%obj.hidenode(tank);
	%obj.hidenode(armor);
	%obj.hidenode(bucket);
}

function EVAJetpackimage::onUnMount(%this, %user)
{
	if(%user.EVAJetpacking)
		return;
	%user.unmountimage(2);
	%user.client.applybodyparts();
}

datablock AudioProfile(EVAJetpackStart)
{
	fileName = "./EVA_jetstart.wav";
	description = AudioClosest3d;
	preload = false;
};

datablock AudioProfile(EVAJetpackLoop)
{
	fileName = "./EVA_jetloop.wav";
	description = AudioClosest3d;
	preload = false;
};

function EVAJetpackLoop(%player)
{
	cancel(%player.EVAJetpackLoop);
	if(%player.EVAJetpacking)
	{
		%player.playAudio(3, EVAJetpackLoop);
		%player.EVAJetpackLoop = schedule(2500, 0, EVAJetpackLoop, %player);
	}
}